﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SoapClient.Provisioning;
using System.Net;
using System.Web.Services.Protocols;

namespace SoapClient
{
    public partial class MyInterface : provisioning
    {

        const string http_username = "ngcpsoap";
        const string http_password = "s04pt3st";

        const string prov_username = "administrator";
        const string prov_password = "administrator";

        public MyInterface()
        {
        }

        public Authentication Auth
        {
            get
            {
                Authentication authParam = new Authentication();
                authParam.type = "admin";
                authParam.username = prov_username;
                authParam.password = prov_password;

                return authParam;
            }
        }

        public MyInterface Request
        {
            get {
                System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate { return true; };

                NetworkCredential credential = new NetworkCredential();
                credential.UserName = http_username;
                credential.Password = http_password;

                Uri uri = new Uri(Url);

                ICredentials credentials = credential.GetCredential(uri, "Basic");
                Credentials = credentials;
                PreAuthenticate = true;

                return this;
            }
 
        }

        public string ObjectToXml(object output)
        {
            string objectAsXmlString;

            System.Xml.Serialization.XmlSerializer xs = new System.Xml.Serialization.XmlSerializer(output.GetType());
            using (System.IO.StringWriter sw = new System.IO.StringWriter())
            {
                try
                {
                    xs.Serialize(sw, output);
                    objectAsXmlString = sw.ToString();
                }
                catch (Exception ex)
                {
                    objectAsXmlString = ex.ToString();
                }
            }

            return objectAsXmlString;
        }

        protected override WebRequest GetWebRequest(Uri uri)
        {
            HttpWebRequest request;
            request = (HttpWebRequest)base.GetWebRequest(uri);

            NetworkCredential networkCredentials =
                Credentials.GetCredential(uri, "Basic");

            if (networkCredentials != null)
            {
                byte[] credentialBuffer = new UTF8Encoding().GetBytes(
                    networkCredentials.UserName + ":" +
                    networkCredentials.Password);
                    request.Headers["Authorization"] =
                        "Basic " + Convert.ToBase64String(credentialBuffer);
            }

            return request;
        }
     }
}
